package kaysaar.aotd_question_of_loyalty.data.intel.secession;

import com.fs.starfarer.api.impl.campaign.intel.raid.ActionStage;
import com.fs.starfarer.api.impl.campaign.ids.Ranks;
import com.fs.starfarer.api.impl.campaign.fleets.FleetFactoryV3;
import com.fs.starfarer.api.impl.campaign.fleets.FleetParamsV3;
import com.fs.starfarer.api.EveryFrameScript;
import org.lwjgl.util.vector.Vector2f;
import java.util.Set;
import com.fs.starfarer.api.ui.SectorMapAPI;
import com.fs.starfarer.api.ui.LabelAPI;
import java.util.Iterator;
import com.fs.starfarer.api.impl.campaign.intel.punitive.PEActionStage;
import java.awt.Color;
import com.fs.starfarer.api.ui.TooltipMakerAPI;
import com.fs.starfarer.api.util.Misc;
import com.fs.starfarer.api.impl.campaign.procgen.themes.BaseAssignmentAI;
import com.fs.starfarer.api.impl.campaign.intel.raid.RaidAssignmentAI;
import com.fs.starfarer.api.impl.campaign.procgen.themes.RouteFleetAssignmentAI;
import com.fs.starfarer.api.impl.campaign.fleets.RouteManager;
import com.fs.starfarer.api.campaign.CampaignFleetAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.campaign.comm.IntelInfoPlugin;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.impl.campaign.intel.punitive.PEReturnStage;
import com.fs.starfarer.api.impl.campaign.intel.punitive.PETravelStage;
import com.fs.starfarer.api.impl.campaign.intel.punitive.PEAssembleStage;
import com.fs.starfarer.api.impl.campaign.intel.punitive.PEOrganizeStage;
import com.fs.starfarer.api.impl.campaign.DebugFlags;
import com.fs.starfarer.api.impl.campaign.fleets.RouteLocationCalculator;
import java.util.Random;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.econ.MarketAPI;
import kaysaar.aotd_question_of_loyalty.data.intel.AoTDSecessionManager;
import com.fs.starfarer.api.impl.campaign.intel.raid.RaidIntel;

public class AoTDSecessionFleetIntel extends RaidIntel implements RaidIntel.RaidDelegate
{
    public static final Object ENTERED_SYSTEM_UPDATE;
    public static final Object OUTCOME_UPDATE;
    protected AoTDSecessionActionStage action;
    protected AoTDSecessionManager.AoTDSecessionGoal goal;
    protected MarketAPI target;
    protected MarketAPI from;
    protected AoTDSecessionOutcome outcome;
    protected FactionAPI factionWantsToTake;
    protected Random random;
    protected AoTDSecessionManager.AoTDSecessionReason reason;
    protected FactionAPI targetFaction;
    protected transient String targetOwner;
    
    public void advance(final float amount) {
        super.advance(amount);
    }
    
    public AoTDSecessionFleetIntel(final FactionAPI faction, final MarketAPI from, final MarketAPI target, final float expeditionFP, final float organizeDuration, final AoTDSecessionManager.AoTDSecessionGoal goal, final AoTDSecessionManager.AoTDSecessionReason bestReason) {
        super(target.getStarSystem(), faction, (RaidIntel.RaidDelegate)null);
        this.random = new Random();
        this.targetOwner = null;
        this.goal = goal;
        this.reason = bestReason;
        this.delegate = (RaidIntel.RaidDelegate)this;
        this.from = from;
        this.target = target;
        this.targetFaction = target.getFaction();
        final SectorEntityToken gather = from.getPrimaryEntity();
        final SectorEntityToken raidJump = (SectorEntityToken)RouteLocationCalculator.findJumpPointToUse(this.getFactionForUIColors(), target.getPrimaryEntity());
        if (gather == null || raidJump == null) {
            this.endImmediately();
            return;
        }
        float orgDur = organizeDuration;
        if (DebugFlags.PUNITIVE_EXPEDITION_DEBUG || DebugFlags.FAST_RAIDS) {
            orgDur = 0.5f;
        }
        this.addStage((RaidIntel.RaidStage)new PEOrganizeStage((RaidIntel)this, from, orgDur));
        final float successMult = 0.5f;
        final PEAssembleStage assemble = new PEAssembleStage((RaidIntel)this, gather);
        assemble.addSource(from);
        assemble.setSpawnFP(expeditionFP);
        assemble.setAbortFP(expeditionFP * successMult);
        this.addStage((RaidIntel.RaidStage)assemble);
        final PETravelStage travel = new PETravelStage((RaidIntel)this, gather, raidJump, false);
        travel.setAbortFP(expeditionFP * successMult);
        this.addStage((RaidIntel.RaidStage)travel);
        (this.action = new AoTDSecessionActionStage(this, target)).setAbortFP(expeditionFP * successMult);
        this.addStage((RaidIntel.RaidStage)this.action);
        this.addStage((RaidIntel.RaidStage)new PEReturnStage((RaidIntel)this));
        this.setImportant(Boolean.valueOf(true));
        Global.getSector().getIntelManager().addIntel((IntelInfoPlugin)this);
    }
    
    public Random getRandom() {
        return this.random;
    }
    
    public MarketAPI getTarget() {
        return this.target;
    }
    
    public FactionAPI getTargetFaction() {
        return this.targetFaction;
    }
    
    public MarketAPI getFrom() {
        return this.from;
    }
    
    public RouteFleetAssignmentAI createAssignmentAI(final CampaignFleetAPI fleet, final RouteManager.RouteData route) {
        final RaidAssignmentAI raidAI = new RaidAssignmentAI(fleet, route, (BaseAssignmentAI.FleetActionDelegate)this.action);
        return (RouteFleetAssignmentAI)raidAI;
    }
    
    protected void advanceImpl(final float amount) {
        super.advanceImpl(amount);
        if (this.target != null && this.targetOwner == null) {
            this.targetOwner = this.target.getFactionId();
        }
        if (this.failStage < 0 && this.targetOwner != null && this.target != null && !this.targetOwner.equals(this.target.getFactionId())) {
            this.forceFail(false);
            this.setOutcome(AoTDSecessionOutcome.AVERTED);
        }
    }
    
    public void sendOutcomeUpdate() {
        this.sendUpdateIfPlayerHasIntel(AoTDSecessionFleetIntel.OUTCOME_UPDATE, false);
    }
    
    public void sendEnteredSystemUpdate() {
        this.sendUpdateIfPlayerHasIntel(AoTDSecessionFleetIntel.ENTERED_SYSTEM_UPDATE, false);
    }
    
    public String getName() {
        final String base = Misc.ucFirst(this.faction.getPersonNamePrefix()) + " Expedition";
        if (this.isEnding()) {
            if (this.isSendingUpdate() && this.isFailed()) {
                return base + " - Has been defeated!";
            }
            if (this.isSucceeded() || this.outcome == AoTDSecessionOutcome.BOMB_SUCCESS) {
                return base + " - Successful";
            }
            if (this.outcome == AoTDSecessionOutcome.RAID_FAIL || this.outcome == AoTDSecessionOutcome.BOMBARD_FAIL || this.outcome == AoTDSecessionOutcome.COLONY_DOES_NOT_EXISTS || this.outcome == AoTDSecessionOutcome.TASK_FORCE_DEFEATED) {
                return base + " - Failed";
            }
        }
        return base;
    }
    
    protected void addBulletPoints(final TooltipMakerAPI info, final IntelInfoPlugin.ListInfoMode mode) {
        final Color h = Misc.getHighlightColor();
        final Color g = Misc.getGrayColor();
        final float pad = 3.0f;
        final float opad = 10.0f;
        float initPad = pad;
        if (mode == IntelInfoPlugin.ListInfoMode.IN_DESC) {
            initPad = opad;
        }
        final Color tc = this.getBulletColorForMode(mode);
        this.bullet(info);
        final FactionAPI other = this.targetFaction;
        if (this.outcome != null) {
            this.generateInfoFromOutcome(this.outcome, info, tc, initPad, other);
            return;
        }
        info.addPara("Target: %s", initPad, tc, other.getBaseUIColor(), new String[] { this.target.getName() });
        initPad = 0.0f;
        if (this.goal == AoTDSecessionManager.AoTDSecessionGoal.BOMBARD) {
            final String goalStr = "saturation bombardment";
            info.addPara("Goal: %s", initPad, tc, Misc.getNegativeHighlightColor(), new String[] { goalStr });
        }
        if (this.goal == AoTDSecessionManager.AoTDSecessionGoal.RETAKE) {
            final String goalStr = "retaking market";
            info.addPara("Goal: %s", initPad, tc, Misc.getNegativeHighlightColor(), new String[] { goalStr });
        }
        final float eta = this.getETA();
        if (eta > 1.0f && !this.isEnding()) {
            final String days = getDaysString(eta);
            info.addPara("Estimated %s " + days + " until arrival", initPad, tc, h, new String[] { "" + Math.round(eta) });
            initPad = 0.0f;
        }
        else if (!this.isEnding() && this.action.getElapsed() > 0.0f) {
            info.addPara("Currently in-system", tc, initPad);
            initPad = 0.0f;
        }
        this.unindent(info);
    }
    
    private void generateInfoFromOutcome(final AoTDSecessionOutcome outcome, final TooltipMakerAPI info, final Color tc, final float initPad, final FactionAPI other) {
        if (outcome == null) {
            info.addPara("%s in danger from %s", initPad, Color.ORANGE, new String[] { this.target.getName(), this.factionWantsToTake.getDisplayName() });
        }
        else if (outcome == AoTDSecessionOutcome.TASK_FORCE_DEFEATED) {
            info.addPara("Retaliatory strike force defeated", tc, initPad);
        }
        else if (outcome == AoTDSecessionOutcome.COLONY_DOES_NOT_EXISTS) {
            info.addPara("Retaliatory strike aborted", tc, initPad);
        }
        else if (outcome == AoTDSecessionOutcome.BOMBARD_FAIL) {
            info.addPara("Bombardment of %s failed", initPad, tc, other.getBaseUIColor(), new String[] { this.target.getName() });
        }
        else if (outcome == AoTDSecessionOutcome.RAID_FAIL) {
            info.addPara("Retaking efforts of %s failed", initPad, tc, other.getBaseUIColor(), new String[] { this.target.getName() });
        }
        else if (outcome != AoTDSecessionOutcome.BOMB_SUCCESS) {
            if (outcome == AoTDSecessionOutcome.RAID_SUCCESS) {
                info.addPara("Retaking efforts of %s have succeeded.", initPad, tc, other.getBaseUIColor(), new String[] { this.target.getName() });
            }
        }
    }
    
    public AoTDSecessionActionStage getActionStage() {
        for (final RaidIntel.RaidStage stage : this.stages) {
            if (stage instanceof PEActionStage) {
                return (AoTDSecessionActionStage)stage;
            }
        }
        return null;
    }
    
    public void createIntelInfo(final TooltipMakerAPI info, final IntelInfoPlugin.ListInfoMode mode) {
        super.createIntelInfo(info, mode);
    }
    
    public void addInitialDescSection(final TooltipMakerAPI info, final float initPad) {
        final Color h = Misc.getHighlightColor();
        final float opad = 10.0f;
        final FactionAPI faction = this.getFaction();
        final String is = faction.getDisplayNameIsOrAre();
        String goalDesc = "";
        String goalHL = "";
        Color goalColor = Misc.getTextColor();
        switch (this.goal) {
            case RETAKE: {
                goalDesc = "an invasion of the colony";
                goalHL = "invasion of the colony";
                goalColor = Misc.getNegativeHighlightColor();
                break;
            }
            case BOMBARD: {
                goalDesc = "a saturation bombardment of the colony";
                goalHL = "saturation bombardment of the colony";
                goalColor = Misc.getNegativeHighlightColor();
                break;
            }
        }
        final String strDesc = this.getRaidStrDesc();
        final int numFleets = (int)this.getOrigNumFleets();
        String fleets = "fleets";
        if (numFleets == 1) {
            fleets = "fleet";
        }
        if (this.outcome == null) {
            final LabelAPI label = info.addPara(Misc.ucFirst(faction.getDisplayNameWithArticle()) + " " + is + " targeting %s with a " + strDesc + " expeditionary force, projected to be comprised of " + numFleets + " " + fleets + ". Its likely goal is " + goalDesc, initPad, faction.getBaseUIColor(), new String[] { this.target.getName() });
            label.setHighlight(new String[] { faction.getDisplayNameWithArticleWithoutArticle(), this.target.getName(), strDesc, "" + numFleets, goalHL });
            label.setHighlightColors(new Color[] { faction.getBaseUIColor(), this.targetFaction.getBaseUIColor(), h, h, goalColor });
        }
        else {
            final LabelAPI label = info.addPara(Misc.ucFirst(faction.getDisplayNameWithArticle()) + " " + is + " targeting %s with an expeditionary force. Its likely goal is " + goalDesc, initPad, faction.getBaseUIColor(), new String[] { this.target.getName() });
            label.setHighlight(new String[] { faction.getDisplayNameWithArticleWithoutArticle(), this.target.getName(), goalHL });
            label.setHighlightColors(new Color[] { faction.getBaseUIColor(), this.targetFaction.getBaseUIColor(), goalColor });
        }
    }
    
    public void sendUpdateIfPlayerHasIntel(final Object listInfoParam, final boolean onlyIfImportant, final boolean sendIfHidden) {
        if (listInfoParam == AoTDSecessionFleetIntel.UPDATE_RETURNING) {
            return;
        }
        super.sendUpdateIfPlayerHasIntel(listInfoParam, onlyIfImportant, sendIfHidden);
    }
    
    public Set<String> getIntelTags(final SectorMapAPI map) {
        final Set<String> tags = super.getIntelTags(map);
        tags.add("Major events");
        tags.add("Colony threats");
        tags.add(this.getFaction().getId());
        return tags;
    }
    
    public void notifyRaidEnded(final RaidIntel raid, final RaidIntel.RaidStageStatus status) {
        if (this.outcome == null && this.failStage >= 0) {
            if (!this.target.isInEconomy() || !this.target.isPlayerOwned()) {
                this.outcome = AoTDSecessionOutcome.COLONY_DOES_NOT_EXISTS;
            }
            else {
                this.outcome = AoTDSecessionOutcome.TASK_FORCE_DEFEATED;
            }
        }
    }
    
    public String getIcon() {
        return this.faction.getCrest();
    }
    
    public AoTDSecessionManager.AoTDSecessionGoal getGoal() {
        return this.goal;
    }
    
    public AoTDSecessionOutcome getOutcome() {
        return this.outcome;
    }
    
    public void setOutcome(final AoTDSecessionOutcome outcome) {
        this.outcome = outcome;
    }
    
    public CampaignFleetAPI spawnFleet(final RouteManager.RouteData route) {
        final Random random = route.getRandom();
        final MarketAPI market = route.getMarket();
        final CampaignFleetAPI fleet = this.createFleet(market.getFactionId(), route, market, null, random);
        if (fleet == null || fleet.isEmpty()) {
            return null;
        }
        market.getContainingLocation().addEntity((SectorEntityToken)fleet);
        fleet.setFacing((float)Math.random() * 360.0f);
        fleet.setLocation(market.getPrimaryEntity().getLocation().x, market.getPrimaryEntity().getLocation().x);
        fleet.addScript((EveryFrameScript)this.createAssignmentAI(fleet, route));
        return fleet;
    }
    
    public CampaignFleetAPI createFleet(final String factionId, final RouteManager.RouteData route, final MarketAPI market, final Vector2f locInHyper, Random random) {
        if (random == null) {
            random = new Random();
        }
        final RouteManager.OptionalFleetData extra = route.getExtra();
        float combat = extra.fp;
        float tanker = extra.fp * (0.1f + random.nextFloat() * 0.05f);
        float transport = extra.fp * (0.1f + random.nextFloat() * 0.05f);
        final float freighter = 0.0f;
        if (this.goal == AoTDSecessionManager.AoTDSecessionGoal.BOMBARD) {
            tanker += transport;
        }
        else {
            transport += tanker / 2.0f;
            tanker *= 0.5f;
        }
        combat -= tanker;
        combat -= transport;
        final FleetParamsV3 params = new FleetParamsV3(market, locInHyper, factionId, (route == null) ? null : route.getQualityOverride(), extra.fleetType, combat, freighter, tanker, transport, 0.0f, 0.0f, 0.0f);
        if (route != null) {
            params.timestamp = route.getTimestamp();
        }
        params.random = random;
        final CampaignFleetAPI fleet = FleetFactoryV3.createFleet(params);
        if (fleet == null || fleet.isEmpty()) {
            return null;
        }
        fleet.getMemoryWithoutUpdate().set("$isWarFleet", (Object)true);
        fleet.getMemoryWithoutUpdate().set("$isRaider", (Object)true);
        if (fleet.getFaction().getCustomBoolean("pirateBehavior")) {
            fleet.getMemoryWithoutUpdate().set("$isPirate", (Object)true);
        }
        final String postId = Ranks.POST_PATROL_COMMANDER;
        final String rankId = Ranks.SPACE_COMMANDER;
        fleet.getCommander().setPostId(postId);
        fleet.getCommander().setRankId(rankId);
        Misc.makeNoRepImpact(fleet, "punex");
        Misc.makeHostile(fleet);
        return fleet;
    }
    
    public AoTDSecessionManager.AoTDSecessionReason getBestReason() {
        return this.reason;
    }
    
    public SectorEntityToken getMapLocation(final SectorMapAPI map) {
        if (this.target != null && this.target.isInEconomy() && this.target.getPrimaryEntity() != null) {
            return this.target.getPrimaryEntity();
        }
        return super.getMapLocation(map);
    }
    
    static {
        ENTERED_SYSTEM_UPDATE = new Object();
        OUTCOME_UPDATE = new Object();
    }
    
    public enum AoTDSecessionOutcome
    {
        TASK_FORCE_DEFEATED, 
        COLONY_HAS_BEEN_TAKEN, 
        COLONY_DOES_NOT_EXISTS, 
        BOMB_SUCCESS, 
        BOMBARD_FAIL, 
        RAID_FAIL, 
        RAID_SUCCESS, 
        AVERTED;
    }
}
